.model small,c
.386
.stack

include support.asm

BIOSSetPixel  PROTO x:WORD,y:WORD,color:WORD
SetPixel_12   PROTO x:WORD,y:WORD,color:WORD
SetPixel_13   PROTO x:WORD,y:WORD,color:WORD

; Host I/O ports for Graphics Controller Address and Data Registers:
;
GraphicsAddressRegister   equ 3ceh
GraphicsDataRegister      equ 3cfh

; Index value for Graphics Controller Set/Reset Register:
;
SetResetIndex             equ 0

; Index value for Graphics Controller Enable Set/Reset Register:
;
EnableSetResetIndex       equ 1

; Index value for Graphics Controller Bit Mask Register:
;
BitMaskIndex              equ 8

outp MACRO port, val
  mov   dx, port
  mov   ax, val
  out   dx, al
ENDM  

.data
    startCount dd 0
.code

.startup

    mov   ax, 0a000h
    mov   es, ax
    mov   ax, 12h
    int   10h

    invoke SetPixel_12, 320, 240, 15
    invoke SetPixel_12, 0, 0, 9
    invoke SetPixel_12, 639, 0, 10
    invoke SetPixel_12, 639, 479, 11
    invoke SetPixel_12, 0, 479, 12
    invoke BIOSSetPixel, 320, 245, 14
    
    print NL,"Press any normal key to continue...",NL
    call waitkey    

    invoke get_tick_count
    push  eax
    mov   ebx, 1000000
    .WHILE ebx
      invoke BIOSSetPixel, 100, 200, 15
      sub   ebx, 1
    .ENDW
    invoke get_tick_count
    pop   ecx
    sub   eax, ecx
    print NL,dword$(eax)," ticks",NL
    
    print NL,"Press any normal key to continue...",NL
    call waitkey
    
    invoke get_tick_count
    push  eax
    mov   ebx, 1000000
    .WHILE ebx
      invoke SetPixel_12, 100, 210, 15
      sub   ebx, 1
    .ENDW
    invoke get_tick_count
    pop   ecx
    sub   eax, ecx
    print NL,dword$(eax)," ticks",NL
    
    print NL,"Press any normal key to continue...",NL
    call waitkey
    
    mov   ax, 13h
    int   10h
    
    invoke SetPixel_13, 160, 100, 15
    invoke SetPixel_13, 0, 0, 9
    invoke SetPixel_13, 319, 0, 10
    invoke SetPixel_13, 319, 199, 11
    invoke SetPixel_13, 0, 199, 12

    invoke get_tick_count
    push  eax
    mov   ebx, 1000000
    .WHILE ebx
      invoke SetPixel_13, 100, 100, 15
      sub   ebx, 1
    .ENDW
    invoke get_tick_count
    pop   ecx
    sub   eax, ecx
    print NL,dword$(eax)," ticks",NL

    print NL,"Press any normal key to exit...",NL
    call waitkey
.exit
  
BIOSSetPixel proc uses ax bx cx dx x:WORD,y:WORD,color:WORD

    mov   ax, color
    mov   ah, 0ch
    mov   bh, 0
    mov   cx, x
    mov   dx, y
    int   10h
    ret

BIOSSetPixel endp
  
; This proc assumes that the VGA is operating in mode 12h,
; and that ES has been loaded with the segment address of
; the graphics display buffer.
; 
; This proc uses the Set/Reset function to write the color
; value for a single pixel to all four bit planes. This
; entails enabling all four bit planes in the Set/Reset
; register, loading the color value into the Set/Reset
; register, and setting the Bit Mask register so the
; write operation will affect only the target pixel.
SetPixel_12 proc uses ax bx cx dx x:WORD,y:WORD,color:WORD

    outp GraphicsAddressRegister,EnableSetResetIndex
    outp GraphicsDataRegister,0fh
    outp GraphicsAddressRegister,SetResetIndex
    outp GraphicsDataRegister,color
    outp GraphicsAddressRegister,BitMaskIndex

    mov   cx, x         ; bit mask = 80h>>(x&7)
    and   cx, 7
    mov   ax, 80h
    shr   ax, cl
    outp GraphicsDataRegister,ax
    
    mov   ax, y         ; pixel byte address = y*80+(x>>3)
    mov   cx, 80
    mul   cx
    mov   bx, ax
    mov   cx, x
    shr   cx, 3
    add   bx, cx

    ; Perform a dummy write to the addressed byte.
    ; The color value for the addressed pixel will be
    ; supplied by the Set/Reset register.
    ;
    mov   BYTE PTR es:[bx], 0

    ; Restore the Bit Mask and Enable Set/Reset registers
    ; to their default values.
    outp GraphicsAddressRegister,BitMaskIndex
    outp GraphicsDataRegister,0ffh
    outp GraphicsAddressRegister,EnableSetResetIndex
    outp GraphicsDataRegister,0
    ret

SetPixel_12 endp

; This proc assumes that the VGA is operating in mode 13h,
; and that ES has been loaded with the segment address of
; the graphics display buffer.
;  
SetPixel_13 proc uses ax bx cx dx x:WORD,y:WORD,color:WORD

    mov   ax, y         ; pixel byte address = y*320+x
    mov   cx, 320
    mul   cx
    mov   bx, ax
    add   bx, x
    mov   ax, color
    mov   es:[bx], al
    ret

SetPixel_13 endp

end